

# CreateRoom
<a name="API_CreateRoom"></a>

Creates a room that allows clients to connect and pass messages.

## Request Syntax
<a name="API_CreateRoom_RequestSyntax"></a>

```
POST /CreateRoom HTTP/1.1
Content-type: application/json

{
   "loggingConfigurationIdentifiers": [ "string" ],
   "maximumMessageLength": number,
   "maximumMessageRatePerSecond": number,
   "messageReviewHandler": { 
      "fallbackResult": "string",
      "uri": "string"
   },
   "name": "string",
   "tags": { 
      "string" : "string" 
   }
}
```

## URI Request Parameters
<a name="API_CreateRoom_RequestParameters"></a>

The request does not use any URI parameters.

## Request Body
<a name="API_CreateRoom_RequestBody"></a>

The request accepts the following data in JSON format.

 ** [loggingConfigurationIdentifiers](#API_CreateRoom_RequestSyntax) **   <a name="ivs-CreateRoom-request-loggingConfigurationIdentifiers"></a>
Array of logging-configuration identifiers attached to the room.  
Type: Array of strings  
Array Members: Minimum number of 0 items. Maximum number of 3 items.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `arn:aws:ivschat:[a-z0-9-]+:[0-9]+:logging-configuration/[a-zA-Z0-9-]+`   
Required: No

 ** [maximumMessageLength](#API_CreateRoom_RequestSyntax) **   <a name="ivs-CreateRoom-request-maximumMessageLength"></a>
Maximum number of characters in a single message. Messages are expected to be UTF-8 encoded and this limit applies specifically to rune/code-point count, not number of bytes. Default: 500.  
Type: Integer  
Valid Range: Minimum value of 1. Maximum value of 500.  
Required: No

 ** [maximumMessageRatePerSecond](#API_CreateRoom_RequestSyntax) **   <a name="ivs-CreateRoom-request-maximumMessageRatePerSecond"></a>
Maximum number of messages per second that can be sent to the room (by all clients). Default: 10.   
Type: Integer  
Valid Range: Minimum value of 1. Maximum value of 100.  
Required: No

 ** [messageReviewHandler](#API_CreateRoom_RequestSyntax) **   <a name="ivs-CreateRoom-request-messageReviewHandler"></a>
Configuration information for optional review of messages.  
Type: [MessageReviewHandler](API_MessageReviewHandler.md) object  
Required: No

 ** [name](#API_CreateRoom_RequestSyntax) **   <a name="ivs-CreateRoom-request-name"></a>
Room name. The value does not need to be unique.  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 128.  
Pattern: `[a-zA-Z0-9-_]*`   
Required: No

 ** [tags](#API_CreateRoom_RequestSyntax) **   <a name="ivs-CreateRoom-request-tags"></a>
Tags to attach to the resource. Array of maps, each of the form `string:string (key:value)`. See [Best practices and strategies](https://docs.aws.amazon.com/tag-editor/latest/userguide/best-practices-and-strats.html) in *Tagging AWS Resources and Tag Editor* for details, including restrictions that apply to tags and "Tag naming limits and requirements"; Amazon IVS Chat has no constraints beyond what is documented there.  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Minimum length of 0. Maximum length of 256.  
Required: No

## Response Syntax
<a name="API_CreateRoom_ResponseSyntax"></a>

```
HTTP/1.1 200
Content-type: application/json

{
   "arn": "string",
   "createTime": "string",
   "id": "string",
   "loggingConfigurationIdentifiers": [ "string" ],
   "maximumMessageLength": number,
   "maximumMessageRatePerSecond": number,
   "messageReviewHandler": { 
      "fallbackResult": "string",
      "uri": "string"
   },
   "name": "string",
   "tags": { 
      "string" : "string" 
   },
   "updateTime": "string"
}
```

## Response Elements
<a name="API_CreateRoom_ResponseElements"></a>

If the action is successful, the service sends back an HTTP 200 response.

The following data is returned in JSON format by the service.

 ** [arn](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-arn"></a>
Room ARN, assigned by the system.  
Type: String  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `arn:aws:ivschat:[a-z0-9-]+:[0-9]+:room/[a-zA-Z0-9-]+` 

 ** [createTime](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-createTime"></a>
Time when the room was created. This is an ISO 8601 timestamp; *note that this is returned as a string*.  
Type: Timestamp

 ** [id](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-id"></a>
Room ID, generated by the system. This is a relative identifier, the part of the ARN that uniquely identifies the room.  
Type: String  
Length Constraints: Fixed length of 12.  
Pattern: `[a-zA-Z0-9]+` 

 ** [loggingConfigurationIdentifiers](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-loggingConfigurationIdentifiers"></a>
Array of logging configurations attached to the room, from the request (if specified).  
Type: Array of strings  
Array Members: Minimum number of 0 items. Maximum number of 3 items.  
Length Constraints: Minimum length of 1. Maximum length of 128.  
Pattern: `arn:aws:ivschat:[a-z0-9-]+:[0-9]+:logging-configuration/[a-zA-Z0-9-]+` 

 ** [maximumMessageLength](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-maximumMessageLength"></a>
Maximum number of characters in a single message, from the request (if specified).  
Type: Integer  
Valid Range: Minimum value of 1. Maximum value of 500.

 ** [maximumMessageRatePerSecond](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-maximumMessageRatePerSecond"></a>
Maximum number of messages per second that can be sent to the room (by all clients), from the request (if specified).  
Type: Integer  
Valid Range: Minimum value of 1. Maximum value of 100.

 ** [messageReviewHandler](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-messageReviewHandler"></a>
Configuration information for optional review of messages.  
Type: [MessageReviewHandler](API_MessageReviewHandler.md) object

 ** [name](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-name"></a>
Room name, from the request (if specified).  
Type: String  
Length Constraints: Minimum length of 0. Maximum length of 128.  
Pattern: `[a-zA-Z0-9-_]*` 

 ** [tags](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-tags"></a>
Tags attached to the resource, from the request (if specified).  
Type: String to string map  
Map Entries: Minimum number of 0 items. Maximum number of 50 items.  
Key Length Constraints: Minimum length of 1. Maximum length of 128.  
Value Length Constraints: Minimum length of 0. Maximum length of 256.

 ** [updateTime](#API_CreateRoom_ResponseSyntax) **   <a name="ivs-CreateRoom-response-updateTime"></a>
Time of the room’s last update. This is an ISO 8601 timestamp; *note that this is returned as a string*.  
Type: Timestamp

## Errors
<a name="API_CreateRoom_Errors"></a>

For information about the errors that are common to all actions, see [Common Error Types](CommonErrors.md).

 ** AccessDeniedException **   
  
HTTP Status Code: 403

 ** ConflictException **   
  
HTTP Status Code: 409

 ** PendingVerification **   
  
HTTP Status Code: 403

 ** ResourceNotFoundException **   
  
HTTP Status Code: 404

 ** ServiceQuotaExceededException **   
  
HTTP Status Code: 402

 ** ValidationException **   
  
HTTP Status Code: 400

## See Also
<a name="API_CreateRoom_SeeAlso"></a>

For more information about using this API in one of the language-specific AWS SDKs, see the following:
+  [AWS Command Line Interface V2](https://docs.aws.amazon.com/goto/cli2/ivschat-2020-07-14/CreateRoom) 
+  [AWS SDK for .NET V4](https://docs.aws.amazon.com/goto/DotNetSDKV4/ivschat-2020-07-14/CreateRoom) 
+  [AWS SDK for C\$1\$1](https://docs.aws.amazon.com/goto/SdkForCpp/ivschat-2020-07-14/CreateRoom) 
+  [AWS SDK for Go v2](https://docs.aws.amazon.com/goto/SdkForGoV2/ivschat-2020-07-14/CreateRoom) 
+  [AWS SDK for Java V2](https://docs.aws.amazon.com/goto/SdkForJavaV2/ivschat-2020-07-14/CreateRoom) 
+  [AWS SDK for JavaScript V3](https://docs.aws.amazon.com/goto/SdkForJavaScriptV3/ivschat-2020-07-14/CreateRoom) 
+  [AWS SDK for Kotlin](https://docs.aws.amazon.com/goto/SdkForKotlin/ivschat-2020-07-14/CreateRoom) 
+  [AWS SDK for PHP V3](https://docs.aws.amazon.com/goto/SdkForPHPV3/ivschat-2020-07-14/CreateRoom) 
+  [AWS SDK for Python](https://docs.aws.amazon.com/goto/boto3/ivschat-2020-07-14/CreateRoom) 
+  [AWS SDK for Ruby V3](https://docs.aws.amazon.com/goto/SdkForRubyV3/ivschat-2020-07-14/CreateRoom) 